#include "mainwindow.h"
#include "ui_mainwindow.h"

bool MainWindow::ReadVideoFile()
{

QString path = "C:/";
QDir directory = path;
QString VideoPath = QFileDialog::getOpenFileName (this, tr("Open the left video file!"), directory.path(),tr("Video Files (*.avi *.mp4 *.mpeg *.mpg)"));
if (VideoPath.isNull() == false)
{
if(Video_Cap.isOpened()){Video_Cap.release();}
Video_Cap.open(VideoPath.toStdString());
if(Video_Cap.isOpened())
{
video_frame_rate = Video_Cap.get(CV_CAP_PROP_FPS); // check the fps and size of the video, video must be VGA 640x480 and 30 or 25fps
capture_width= Video_Cap.get(CV_CAP_PROP_FRAME_WIDTH);
capture_height= Video_Cap.get(CV_CAP_PROP_FRAME_HEIGHT);
if(video_frame_rate == 30 || video_frame_rate == 25 && capture_width == 640 && capture_height == 480 )
{
Console("Video file was opened!",true);
Video_Cap>>RawImage;
RawImage.copyTo(DestinationImage);
return true;
}
else
{
Console("Video must be VGA 640x480px with 25/30 fps!",false);
return false;
}
}
else
{
Console("Error open the video file!",false);

return false;
}
}
else
{
return false;
}
return false;
}



bool MainWindow::CheckWebcam()
{
if(CameraCapture.isOpened()){CameraCapture.release();}

CameraCapture.open(0);
if(CameraCapture.isOpened())
{
CameraCapture>>RawImage;
RawImage.copyTo(DestinationImage);
return true;
}
else
{
return false;
}

}

