#include "mainwindow.h"
#include "ui_mainwindow.h"

void MainWindow::RefreshScreen()
{





    mServer.GetTrackingData(TrackingData);




    if(!RawImage.empty())
    {
    cv::resize(RawImage,L_CameraImage,Size(320,240), 0, 0, cv::INTER_LINEAR);
    L_CameraImage.copyTo(RGB_Image);
    if(ZoomOnOff == true){ZoomFunction();}


     ui->L_Screen->showImage(L_CameraImage);

    }

    if(!DestinationImage.empty())
    {
    cv::resize(DestinationImage,R_CameraImage,Size(320,240), 0, 0, cv::INTER_LINEAR);
    ui->R_Screen->showImage(R_CameraImage);
    }






}



void MainWindow::ZoomFunction()
{

    Point RectanglePosition;

    if(MousePosition.x>15 && MousePosition.x<305 && MousePosition.y>15 && MousePosition.y<225)
    {
    RectanglePosition = MousePosition;
    }
    else
    {
      RectanglePosition = MousePosition;
      if(RectanglePosition.x<15){RectanglePosition.x = 15;}
      if(RectanglePosition.y<15){RectanglePosition.y = 15;}
      if(RectanglePosition.x>305){RectanglePosition.x = 305;}
      if(RectanglePosition.y>225){RectanglePosition.y = 225;}
    }

    Rect ZoomArea(Point(RectanglePosition.x-15,RectanglePosition.y-15),Point(RectanglePosition.x+14,RectanglePosition.y+14));
    Rect ZoomArea640;
    ZoomArea640.x = ZoomArea.x * 2;
    ZoomArea640.y = ZoomArea.y * 2;
    ZoomArea640.width = (ZoomArea.width*2);
    ZoomArea640.height = (ZoomArea.height*2);


    RawImage(ZoomArea640).copyTo(ZoomImage);
    rectangle(L_CameraImage, Point(RectanglePosition.x-15,RectanglePosition.y-15),Point(RectanglePosition.x+14,RectanglePosition.y+14), CV_RGB(0,255,255)); // mouth area


    if(!ZoomImage.empty())
    {
    cv::resize(ZoomImage,Zoom_CameraImage,Size(120,120), 0, 0, cv::INTER_LINEAR);
    rectangle(Zoom_CameraImage, Point(50,58),Point(57,62),CV_RGB(0,255,0),-1,8);
    rectangle(Zoom_CameraImage, Point(63,58),Point(70,62),CV_RGB(0,255,0),-1,8);
    rectangle(Zoom_CameraImage, Point(58,50),Point(62,57),CV_RGB(0,255,0),-1,8);
    rectangle(Zoom_CameraImage, Point(58,63),Point(62,70),CV_RGB(0,255,0),-1,8);
    rectangle(Zoom_CameraImage, Point(50,58),Point(57,62),CV_RGB(0,0,0),1,8);
    rectangle(Zoom_CameraImage, Point(63,58),Point(70,62),CV_RGB(0,0,0),1,8);
    rectangle(Zoom_CameraImage, Point(58,50),Point(62,57),CV_RGB(0,0,0),1,8);
    rectangle(Zoom_CameraImage, Point(58,63),Point(62,70),CV_RGB(0,0,0),1,8);


    ui->ROI_Screen->showImage(Zoom_CameraImage);
    }



}

