#include "threadworker.h"



void ThreadWorker::DataProcessing()
{


//////////////////////PROCESS ALL DATA //////////////////////////////////


int HA = abs(HeadAngle);
int GD = abs(GazeDirection)*999;



////////////////////////////////////////////////////////////////////////

QString ID;


TrackingData.clear();

if(CycleDetected<8)
{
ID = "FT00";
}
else
{
ID = "FT10";
}

QTextStream(&TrackingData)<<ID;
for(int i=0;i<=9;i++) // trackers
{
QString Xsign,Ysign;
if (fTrackers[i].x < 0){Xsign = QString::number(0);} else{Xsign = QString::number(1);}
if (fTrackers[i].y < 0){Ysign = QString::number(0);} else{Ysign = QString::number(1);}

QString X = QString("%1").arg(uint(abs(fTrackers[i].x)));
X = X.rightJustified(3,'0');
QString Y = QString("%1").arg(uint(abs(fTrackers[i].y)));
Y = Y.rightJustified(3,'0');

QTextStream(&TrackingData)<<Xsign<<X<<Ysign<<Y;
}


if(HeadAngle>=0){QTextStream(&TrackingData)<<"1";} // head angle
if(HeadAngle<0){QTextStream(&TrackingData)<<"0";}

QString Angle = QString("%1").arg(HA);
Angle = Angle.rightJustified(2,'0');
QTextStream(&TrackingData)<<Angle;


if(GazeDirection>=0){QTextStream(&TrackingData)<<"1";} // gaze direction
if(GazeDirection<0){QTextStream(&TrackingData)<<"0";}

QString Gaze = QString("%1").arg(GD);
Gaze = Gaze.rightJustified(4,'0');
QTextStream(&TrackingData)<<Gaze;

//qDebug()<<TrackingData;

}





