#include "threadworker.h"

void ThreadWorker::MarkerSelector()
{

uint BlurSize = 3;
Mat mask;
uint sum;
Point Corner;
uint ECount = 6;
Point EPoints[ECount];
uint MCount = 4;
Point MPoints[MCount];
bool Eyes = false;
bool Mouth = false;




for(int part = 1; part<=2; part++) /////////////////////////// CHANGE THIS TO 2
{
if(part == 1){Corner =RoiPoints[2]; mask = RoiEyesMask;}
else{Corner =RoiPoints[6]; mask = RoiMouthMask;}


GaussianBlur(mask,mask,Size(BlurSize,BlurSize),0,0,BORDER_DEFAULT);
sum = Scalar(cv::sum(mask))[0];
sum /=(mask.cols * mask.rows); // sum shows the average brightness value for the whole area
if(sum < 4) // let's find some contours
{


std::vector<std::vector<cv::Point> > contours;
findContours(mask.clone(), contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE);
// Fill holes in each contour
drawContours(mask, contours, -1, CV_RGB(255,255,255), -1);

uint CountOfDetections = contours.size();


if(part == 1 && CountOfDetections >= ECount) // start of part 1 ////////////////////////////////////////////////
{
ColorPoint Points[CountOfDetections];
for (int i = 0; i < CountOfDetections; i++) // get the points
{
Points[i].SetArea(cv::contourArea(contours[i]));
Points[i].SetRec(cv::boundingRect(contours[i]));
}

if(CountOfDetections>ECount)
{
    for (int j = 0; j <(CountOfDetections-1); j++) // sort the points due to their area
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( Points[i+1].area >  Points[i].area){swap(Points[i],Points[i+1]);}
    }
    }

}

for (int i = 0; i < ECount; i++)
{
EPoints[i] =  Points[i].pos;
}

for (int j = 0; j <(ECount-1); j++) // horizontal sort the points
{
for (int i = 0; i <(ECount-1); i++)
{
    if(EPoints[i+1].x < EPoints[i].x){swap(EPoints[i],EPoints[i+1]);}
}
}
for(int i=0;i<ECount;i++)
{
EPoints[i] += Corner;

}

Eyes = true;
} // end of part 1

if(part == 2 && CountOfDetections >= MCount) // start of part 2 ////////////////////////////////////////////////
{
ColorPoint Points[CountOfDetections];
for (int i = 0; i < CountOfDetections; i++) // get the points
{
Points[i].SetArea(cv::contourArea(contours[i]));
Points[i].SetRec(cv::boundingRect(contours[i]));
}

if(CountOfDetections>MCount)
{
    for (int j = 0; j <(CountOfDetections-1); j++) // sort the points due to their area
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( Points[i+1].area >  Points[i].area){swap(Points[i],Points[i+1]);}
    }
    }

}

Point BufPoints[MCount];

for (int i = 0; i < MCount; i++)
{
MPoints[i] =  Points[i].pos;
}

for (int j = 0; j <(MCount-1); j++) // horizontal sort the points
{
for (int i = 0; i <(MCount-1); i++)
{
    if(MPoints[i+1].x < MPoints[i].x){swap(MPoints[i],MPoints[i+1]);}
}
}
BufPoints[0] = MPoints[0];
BufPoints[2] = MPoints[3];

for (int j = 0; j <(MCount-1); j++) // vertical sort the points
{
for (int i = 0; i <(MCount-1); i++)
{
    if(MPoints[i+1].y < MPoints[i].y){swap(MPoints[i],MPoints[i+1]);}
}
}
BufPoints[1] = MPoints[0];
BufPoints[3] = MPoints[3];

for(int i=0;i<MCount;i++)
{
MPoints[i] = BufPoints[i] + Corner;
}
Mouth = true;
} // end of part 1

}
}

if(Eyes == true) // check the points and write in Trackers
{
    bool check = true;
    for(int i=0;i<ECount-1;i++)
    {
    if(EPoints[i].x>EPoints[i+1].x){check = false;}
    }
    if(check == true)
    {
    for(int i=0;i<ECount;i++)
    {
    Trackers[i+1] = EPoints[i];
    }
    }

}

if(Mouth == true) // check the points and write in Trackers
{
    Point L = MPoints[0];
    Point U = MPoints[1];
    Point R = MPoints[2];
    Point D = MPoints[3];

    uint sum = 0;
    if(L.x < U.x && L.x < D.x && L.x < R.x)
    {sum+=1;}
    if(R.x > U.x && R.x > D.x && R.x > L.x)
    {sum+=1;}
    if(U.y < L.y && U.y < R.y && U.y < D.y)
    {sum+=1; }
    if(D.y > L.y && D.y > R.y && D.y > U.y)
    {sum+=1;}


    if(sum >= 4)
    {
    Trackers[9]  = L;
    Trackers[10] = U;
    Trackers[11] = R;
    Trackers[12] = D;
}
}



}


