#include "threadworker.h"


void ThreadWorker::CreateColorMask(Mat *RawFrame)
{


Mat HSV_Frame;
vector<Mat> HSV_Channels;

Mat Masks[3] = Mat::zeros(Frame.rows,Frame.cols,CV_8UC1);
Mat FinalMask = Mat::zeros(Frame.rows,Frame.cols,CV_8UC1);


for(int i=0;i<=ColorCountHSV;i++)
{


Mat Frame = *RawFrame;

cvtColor(Frame,HSV_Frame,CV_BGR2HSV);

split(HSV_Frame,HSV_Channels);



inRange(HSV_Channels[0],HSV_Colors[0][i]-HSV_Colors[3][i],HSV_Colors[0][i]+HSV_Colors[3][i],HSV_Channels[0]);
inRange(HSV_Channels[1],HSV_Colors[1][i]-HSV_Colors[3][i],HSV_Colors[1][i]+HSV_Colors[3][i],HSV_Channels[1]);
inRange(HSV_Channels[2],HSV_Colors[2][i]-HSV_Colors[3][i],HSV_Colors[2][i]+HSV_Colors[3][i],HSV_Channels[2]);



merge(HSV_Channels,HSV_Frame);
cvtColor(HSV_Frame,HSV_Frame,CV_BGR2GRAY);
threshold(HSV_Frame,Masks[i],254,255,0);
}





if(ColorCountHSV > 0)
{

for(int i=1;i<=ColorCountHSV;i++)
{
cv::bitwise_or(Masks[0],Masks[i],Masks[0],noArray());
}

}

FinalMask = Masks[0];

ColorMask = FinalMask;

}

