#-------------------------------------------------
#
# Project created by QtCreator 2013-11-15T14:40:20
#
#-------------------------------------------------

QT       += core
QT       += network
QT       += gui
QT       += opengl

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets
TARGET = FaceTracker
TEMPLATE = app
SOURCES += main.cpp\
        mainwindow.cpp \
    MW_buttons.cpp \
    MW_start.cpp \
    MW_tracking_trigger.cpp \
    threadworker.cpp \
    MW_refresh.cpp \
    MW_end.cpp \
    T_eye_tracker.cpp \
    T_Roi.cpp \
    T_Start.cpp \
    T_Drawer.cpp \
    my_qlistwidget.cpp \
    MW_mouse_functions.cpp \
    MW_GetColorValue.cpp \
    T_Masking.cpp \
    T_Mouth_Tracker.cpp \
    MW_CaptureStart.cpp \
    MW_Check_Webcam_and_Video.cpp \
    myserver.cpp \
    T_Data_Processing.cpp \
    MW_Console.cpp \
    T_Functions.cpp \
    T_eyebrow_tracker.cpp \
    T_gaze_detector.cpp \
    T_Align_Trackers.cpp \
    T_Smooth_Trackers.cpp \
    T_Marker_Selector.cpp \
    T_eyebrow_detector.cpp \
    MW_Save_Load_Data.cpp

HEADERS  += mainwindow.h \
    threadworker.h \
    my_qlistwidget.h \
    myserver.h \
    T_User_Classes.h

FORMS    += mainwindow.ui




CONFIG += exceptions
INCLUDEPATH +=C:/opencv/opencv/build/include
LIBS += -LC:\\opencv\\mybuild\\lib \
-lopencv_contrib246 \
-lopencv_stitching246 \
-lopencv_nonfree246 \
-lopencv_superres246 \
-lopencv_ts246 \
-lopencv_videostab246 \
-lopencv_gpu246 \
-lopencv_legacy246 \
-lopencv_ml246 \
-lopencv_objdetect246 \
-lopencv_calib3d246 \
-lopencv_photo246 \
-lopencv_video246 \
-lopencv_features2d246 \
-lopencv_highgui246 \
-llibjasper \
-lIlmImf \
-llibtiff \
-llibpng \
-llibjpeg \
-lopencv_flann246 \
-lopencv_imgproc246 \
-lopencv_core246 \
-lzlib \
-lopencv_haartraining_engine
LIBS += -LC:\\ProgramFiles\\MicrosoftSDKs\\Windows\\v7.0\\Lib \
-lVfw32 \
-lmsvfw32 \
-lComCtl32 \
-lGdi32 \
-lddraw \
-ldxguid \
-lole32 \
-loleaut32 \
-lUuid


