#include "mainwindow.h"
#include "ui_mainwindow.h"

int compare (const void * a, const void * b)
{
  return ( *(uint*)a - *(uint*)b );
}


void MainWindow::GetColorValue()
{

Mat HSV_Image;
cvtColor(RGB_Image,HSV_Image,CV_BGR2HSV);
uint pos_x = MousePosition.x-1;
uint pos_y = MousePosition.y-1;
//uint pos_x = MousePosition.x;
//uint pos_y = MousePosition.y;

uint H_v[9];
uint S_v[9];
uint V_v[9];
uint k =0;


for(int i = 0;i<3;i++)  // this loop will read values of 9 pixels around the selected one
{
for(int j = 0;j<3;j++)
{

H_v[k] = HSV_Image.at<Vec3b>(pos_y+j,pos_x+i)[0];
S_v[k] = HSV_Image.at<Vec3b>(pos_y+j,pos_x+i)[1];
V_v[k] = HSV_Image.at<Vec3b>(pos_y+j,pos_x+i)[2];
k++;
}
}

qsort (H_v,9, sizeof(uint), compare); // sort the values ascend
qsort (S_v,9, sizeof(uint), compare);
qsort (V_v,9, sizeof(uint), compare);

H_value =0;
S_value =0;
V_value =0;


for(int i = 2;i<7;i++)
{
    H_value +=H_v[i];
    S_value +=S_v[i];
    V_value +=V_v[i];
}



H_value /=5;
S_value /=5;
V_value /=5;


/*
H_value = HSV_Image.at<Vec3b>(pos_y,pos_x)[0];
S_value = HSV_Image.at<Vec3b>(pos_y,pos_x)[1];
V_value = HSV_Image.at<Vec3b>(pos_y,pos_x)[2];
*/
HSV_Image.release();

EmitPermission = false; // don't emit any signal from sliders until all slider values will be changed
ui->Slider_H->setValue(H_value);
ui->Slider_S->setValue(S_value);
ui->Slider_V->setValue(V_value);
ui->Slider_R->setValue(R_value);
emit emit_HSV_data(&H_value,&S_value,&V_value,&R_value);
EmitPermission = true;
}


