#include "mainwindow.h"
#include "ui_mainwindow.h"



void MainWindow::on_Button_Save_HSV_clicked()
{
SaveData();
}

void MainWindow::on_Button_Load_HSV_clicked()
{
LoadData();
}


/////////////////////////////////////////////////TRACKING METHODS ////////////////////////////////////




void MainWindow::on_Button_TrackingMethod_clicked()
{
    if(ColorTrack == false)
    {
        ColorTrack =  true; ui->Button_TrackingMethod->setText("Color Track Off");
    }
    else
    {
       ColorTrack =  false; ui->Button_TrackingMethod->setText("Color Track On");
    }
emit emit_TrackingMethod(&ColorTrack);
}
///////////////////////////////////////////////////EYEBROWS////////////////////////////////////////////


void MainWindow::on_Slider_EB_B_valueChanged(int value)
{
EbBlur1 = (value *2) +1;
ui->EB_V_B->setText(QString::number(EbBlur1));
emit emit_EB_data(&EbBlur1,&EbBlur2);
}

void MainWindow::on_Slider_EB_B_2_valueChanged(int value)
{
EbBlur2 = (value *2) +1;
ui->EB_V_B_2->setText(QString::number(EbBlur2));
emit emit_EB_data(&EbBlur1,&EbBlur2);
}


///////////////////////////////////////////////////////EYES//////////////////////////////////////////////
void MainWindow::on_Slider_E_Roi_valueChanged(int value)
{
EyesAreaSize = value;
ui->E_V_P->setText(QString::number(value));
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}

void MainWindow::on_Slider_E_Brith_valueChanged(int value)
{
EyesDarkPoint = value;
ui->E_V_Brith->setText(QString::number(value));
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}

void MainWindow::on_Slider_E_Max_valueChanged(int value)
{
EyesMaxMov = value;
ui->E_V_Max->setText(QString::number(value));
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}

void MainWindow::on_Slider_E_Min_valueChanged(int value)
{
EyesMinMov  = value;
ui->E_V_Min->setText(QString::number(value));
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}

void MainWindow::on_Slider_E_Blur_valueChanged(int value)
{
EyesBlur =(value *2) +1;
ui->E_V_Blur->setText(QString::number((value*2)+1));
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}


void MainWindow::on_Slider_E_D_valueChanged(int value)
{
EyesDepth = value;
ui->E_V_D->setText(QString::number(value));
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}



void MainWindow::on_E_CH_clicked(bool checked)
{
EyesFastTracking = checked;
emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
}













void MainWindow::on_Button_Port_clicked()
{
    Port = ui->textInputPort->toPlainText();
}




void MainWindow::on_comboBox_Sources_activated(int index)
{




    if(CountOfItems == 2)
    {
       switch (index)
       {
       case 0: Source ="Webcam"; if(CheckWebcam()== true)  {SourceReady = true; ui->Button_Camera->setEnabled(true); RefreshScreen(); }else{SourceReady = false;  ui->Button_Camera->setEnabled(false);}  break;
       case 1: Source ="Video"; if(ReadVideoFile()== true) {SourceReady = true; ui->Button_Camera->setEnabled(true); RefreshScreen(); }else{SourceReady = false; ui->Button_Camera->setEnabled(false);}  break;
       default:  break;
       }

    }

    if(CountOfItems == 1)
    {
       switch (index)
       {
       case 0: Source ="Video"; if(ReadVideoFile()== true) {SourceReady = true; ui->Button_Camera->setEnabled(true);  RefreshScreen();}else{SourceReady = false;  ui->Button_Camera->setEnabled(false);}  break;
       default:  break;
       }

    }



}






void MainWindow::on_Button_Hold_Frame_clicked()
{
    if(HoldFrame == false){HoldFrame = true; ui->Button_Hold_Frame->setText(QString(">"));}
    else{HoldFrame = false; ui->Button_Hold_Frame->setText(QString("||"));}

}




void MainWindow::on_comboBox_R_Screen_currentIndexChanged(int index)
{
   ComboBoxIndex = index;
   emit emit_ComboBoxIndex(&ComboBoxIndex);
}


void MainWindow::on_Button_Masking_On_Off_clicked()
{


MaskingOnOff = true;


}



void MainWindow::on_Button_DeleteColor_clicked()
{
ColorNumber = 0;
ColorChannel--;
ui->L_1->setText(QString::number(ColorChannel+1));
emit_ColorIndex(&ColorNumber);

if(ColorChannel <= 2){ui->Button_AddColor->setEnabled(true);}
if(ColorChannel == 0){ui->Button_DeleteColor->setEnabled(false); }
}



void MainWindow::on_Button_AddColor_clicked()
{ 
ColorNumber = 1;
ColorChannel++;
ui->L_1->setText(QString::number(ColorChannel+1));
emit_ColorIndex(&ColorNumber);

if(ColorChannel == 2){ui->Button_AddColor->setEnabled(false);}
if(ColorChannel > 0){ui->Button_DeleteColor->setEnabled(true);}

}






void MainWindow::on_Button_Zoom_clicked()
{
    if(ZoomOnOff == false)
    {
    ui->Button_Zoom->setText(QString("Zoom Off"));
    ZoomOnOff = true;
    }
    else
    {
    ui->Button_Zoom->setText(QString("Zoom On"));
    ZoomOnOff = false;
    }


}




void MainWindow::on_Button_Camera_clicked()
{

    if(CameraStream == false)
    {
        ui->Button_Camera->setText("Stop");
        ui->comboBox_Sources->setEnabled(false);
        ui->Button_Port->setEnabled(false);
        ui->textInputPort->setEnabled(false);
        ui->Button_Hold_Frame->setEnabled(true);

        CaptureStart();

    }
    else
    {
        ui->Button_Camera->setText("Track");
       ui->comboBox_Sources->setEnabled(true);
       ui->Button_Port->setEnabled(true);
       ui->textInputPort->setEnabled(true);
       ui->Button_Hold_Frame->setEnabled(false);
        CaptureStop();
    }



}







void MainWindow::on_Slider_L_G_valueChanged(int value)
{
LipsG  = (float(value))/100;
emit emit_LIPS_data(&LipsG,&LipsB);
ui->L_G->setText(QString::number(LipsG));
}

void MainWindow::on_Slider_L_B_valueChanged(int value)
{
LipsB  = (float(value))/100;
emit emit_LIPS_data(&LipsG,&LipsB);
ui->L_B->setText(QString::number(LipsB));
}



void MainWindow::on_Slider_H_valueChanged(int value)
{
H_value = value;  ui->H->setText(QString("H:%1").arg(H_value));
if(EmitPermission == true) { emit emit_HSV_data(&H_value,&S_value,&V_value,&R_value);}
}

void MainWindow::on_Slider_S_valueChanged(int value)
{
S_value = value;   ui->S->setText(QString("S:%1").arg(S_value));
if(EmitPermission == true) { emit emit_HSV_data(&H_value,&S_value,&V_value,&R_value);}
}

void MainWindow::on_Slider_V_valueChanged(int value)
{
V_value = value; ui->V->setText(QString("V:%1").arg(V_value));
if(EmitPermission == true) { emit emit_HSV_data(&H_value,&S_value,&V_value,&R_value);}
}


void MainWindow::on_Slider_R_valueChanged(int value)
{
R_value = value; ui->R->setText(QString("R:%1").arg(R_value));
if(EmitPermission == true) { emit emit_HSV_data(&H_value,&S_value,&V_value,&R_value);}
}
