#include "threadworker.h"

void ThreadWorker::AlignTrackers()
{
Point2f Pivot = Trackers[0];
double a =  (Trackers[7].y - Trackers[8].y);
double b =  abs(Trackers[8].x - Trackers[7].x);
double Angle  = (180/PI)*(atan(a/b)); // compute the angle

HeadAngle = -Angle;

for(int i=0;i<=12;i++)
{
aTrackers[i] = RotatePoint(Pivot,Trackers[i],Angle);
dTrackers[i] = aTrackers[i] - aTrackers[10]; // fixation point
}

Point2f MiddlePoint(Frame.cols/2,Frame.rows/2); // face is fixed on face middle point
for(int i=1;i<=12;i++)
{
dTrackers[i] +=MiddlePoint;
}



}


