#include "threadworker.h"

void ThreadWorker::SmoothTrackers()
{

int size;


Point MiddlePoint(Frame.cols/2,Frame.rows/2);
uint shift = 64;
Point LU((MiddlePoint.x - (Frame.rows/2) + shift),(MiddlePoint.y - (Frame.rows/2) + shift));
Point RD((MiddlePoint.x + (Frame.rows/2) - shift),(MiddlePoint.y + (Frame.rows/2) - shift));

double x = RD.x - LU.x;
double mult = 1000/x;







size = sizeof(GazeSmoothMem)/sizeof(GazeSmoothMem[0]);
if(!GazeSmoothMem[0])
{
for(int i=0;i<size;i++)
{
GazeSmoothMem[i] = GazeDirection;
}
}
else
{
for(int i=size-1;i>0;i--)
{
GazeSmoothMem[i] = GazeSmoothMem[i-1];
}
GazeSmoothMem[0] = GazeDirection;
GazeDirection = 0;
for(int i=0;i<size;i++)
{
GazeDirection +=GazeSmoothMem[i]/size;
}
}




size = sizeof(AngleSmoothMem)/sizeof(AngleSmoothMem[0]);
if(!AngleSmoothMem[0])
{
for(int i=0;i<size;i++)
{
AngleSmoothMem[i] = HeadAngle;
}
}
else
{
for(int i=size-1;i>0;i--)
{
AngleSmoothMem[i] = AngleSmoothMem[i-1];
}
AngleSmoothMem[0] = HeadAngle;
HeadAngle = 0;
for(int i=0;i<size;i++)
{
HeadAngle +=AngleSmoothMem[i]/size;
}
}



size = (sizeof(TrackingPointsMemX[0])/sizeof(TrackingPointsMemX[0][0]));
for(int pn=1;pn<=12;pn++) // smooth trackers X
{
if(!TrackingPointsMemX[pn][0])
{
for(int i=0;i<size;i++)
{
TrackingPointsMemX[pn][i] = dTrackers[pn].x;
}
}
else
{

for(int i=size-1;i>0;i--)
{
TrackingPointsMemX[pn][i] = TrackingPointsMemX[pn][i-1];
}
TrackingPointsMemX[pn][0] = dTrackers[pn].x;
double res = 0;
for(int i=0;i<size;i++)
{
res+=TrackingPointsMemX[pn][i]/double(size);
}
sTrackers[pn].x = res;
}
}


size = (sizeof(TrackingPointsMemY[0])/sizeof(TrackingPointsMemY[0][0]));
for(int pn=1;pn<=12;pn++) // smooth trackers Y
{
if(!TrackingPointsMemY[pn][0])
{
for(int i=0;i<size;i++)
{
TrackingPointsMemY[pn][i] = dTrackers[pn].y;
}
}
else
{

for(int i=size-1;i>0;i--)
{
TrackingPointsMemY[pn][i] = TrackingPointsMemY[pn][i-1];
}
TrackingPointsMemY[pn][0] = dTrackers[pn].y;
double res = 0;
for(int i=0;i<size;i++)
{
res +=TrackingPointsMemY[pn][i]/double(size);
}
sTrackers[pn].y =  res;
}

}





// make Eyebrow points relative
Point2f LeftEye,RightEye;
LeftEye.x = MiddlePoint.x - (48);
LeftEye.y = MiddlePoint.y - 64;
RightEye.x = MiddlePoint.x + (48);
RightEye.y = MiddlePoint.y - 64;

for(int i=1;i<=3;i++)
{
sTrackers[i].y -= sTrackers[7].y;
sTrackers[i].x -= LeftEye.x;
sTrackers[i] += LeftEye;
}
for(int i=4;i<=6;i++)
{
sTrackers[i].y -= sTrackers[8].y;
sTrackers[i].x -= RightEye.x;
sTrackers[i] += RightEye;
}
sTrackers[7] = LeftEye;
sTrackers[8] = RightEye;



// make trackers relative

rTrackers[0] = sTrackers[1] - sTrackers[7];
rTrackers[1] = sTrackers[2] - sTrackers[7];
rTrackers[2] = sTrackers[3] - sTrackers[7];

rTrackers[3] = sTrackers[4] - sTrackers[8];
rTrackers[4] = sTrackers[5] - sTrackers[8];
rTrackers[5] = sTrackers[6] - sTrackers[8];

rTrackers[6] = sTrackers[9] - sTrackers[10];
rTrackers[7] = Point(0,0);
rTrackers[8] = sTrackers[11] - sTrackers[10];
rTrackers[9] = sTrackers[12] - sTrackers[10];


for(int i=0;i<=9;i++)
{
fTrackers[i] = rTrackers[i];
fTrackers[i].x *= mult;
fTrackers[i].y *= mult;
}



}
