#include "threadworker.h"



void ThreadWorker::EyeTrackerRun()
{


uint MaxValueDepth = EyesDepth;
bool FastTrack;
uint FocusAreaSize = EyesAreaSize;
int  DarkPointRange = EyesDarkPoint;
int MaxMovementRange = EyesMaxMov;
int MinMovementRange = EyesMinMov;
uint BlurSize = EyesBlur;

Point LCorner,RCorner;

if(CycleDetected > 8 && EyesFastTracking == true ){FastTrack = true;}
else{FastTrack = false;}


Mat gray;
Mat src;

for(int eye = 1; eye<=2 ; eye ++)   ///////// Calculate for both eyes
{

////////////////////SET THE FOCUS AREAS //////////////////////////////////
if(FastTrack == true)
{

if(eye == 1)
{
    if(Trackers[7].x < (RoiPoints[2].x +FocusAreaSize)) {Trackers[7].x =RoiPoints[2].x + FocusAreaSize;}
    if(Trackers[7].x > (RoiPoints[3].x -FocusAreaSize)) {Trackers[7].x =RoiPoints[3].x - FocusAreaSize;}

    if(Trackers[7].y < (RoiPoints[2].y +FocusAreaSize)) {Trackers[7].y =RoiPoints[2].y + FocusAreaSize;}
    if(Trackers[7].y > (RoiPoints[3].y -FocusAreaSize)) {Trackers[7].y =RoiPoints[3].y - FocusAreaSize;}

    Point L_Eye_LU(Trackers[7].x - FocusAreaSize,Trackers[7].y - FocusAreaSize);    // set the points for small roi's
    Point L_Eye_RD(Trackers[7].x + FocusAreaSize,Trackers[7].y + FocusAreaSize);

    Rect LRoi(L_Eye_LU,L_Eye_RD);
    if(LRoi.width <= 0 && LRoi.height <= 0)
    {
    FastTrack = false;
    }
    else
    {
    Frame(LRoi).copyTo(src);
    LCorner = L_Eye_LU;
    rectangle(Frame_Trackers, L_Eye_LU,L_Eye_RD, CV_RGB(255,0,0));

    }
}
else
{
    if(Trackers[8].x < (RoiPoints[4].x +FocusAreaSize)) {Trackers[8].x =RoiPoints[4].x + FocusAreaSize;}
    if(Trackers[8].x > (RoiPoints[5].x -FocusAreaSize)) {Trackers[8].x =RoiPoints[5].x - FocusAreaSize;}

    if(Trackers[8].y < (RoiPoints[4].y +FocusAreaSize)) {Trackers[8].y =RoiPoints[4].y + FocusAreaSize;}
    if(Trackers[8].y > (RoiPoints[5].y -FocusAreaSize)) {Trackers[8].y =RoiPoints[5].y - FocusAreaSize;}

    Point R_Eye_LU(Trackers[8].x - FocusAreaSize,Trackers[8].y - FocusAreaSize);
    Point R_Eye_RD(Trackers[8].x + FocusAreaSize,Trackers[8].y + FocusAreaSize);


    Rect RRoi(R_Eye_LU,R_Eye_RD);
    if( RRoi.width <= 0 && RRoi.height <= 0)
    {
    FastTrack = false;
    }
    else
    {
    Frame(RRoi).copyTo(src);
    RCorner = R_Eye_LU;
    rectangle(Frame_Trackers, R_Eye_LU,R_Eye_RD, CV_RGB(0,0,255));
    }
}

}

else
{
//////////////////////GET THE MAIN SOURCE ///////////////////////////
if(eye == 1){src = RoiEyeLeft; LCorner = RoiPoints[2];}
else{src = RoiEyeRight; RCorner = RoiPoints[4];}
}



//////////////////////////////////BLUR IMAGE AND INVERT IT //////////////////////
cv::cvtColor(~src,gray,CV_BGR2GRAY);
GaussianBlur(gray,gray,Size(BlurSize,BlurSize),0,0,BORDER_DEFAULT);


//////////////////FIND REALLY CORRECT MIN VALUE ///////////////////////

double maxvalue;
double minvalue;

Point RDCorner;
RDCorner.x = gray.cols;
RDCorner.y = gray.rows;

Point LDCorner;
LDCorner.x = 0;
LDCorner.y = gray.rows;

Point MidPoint;
MidPoint.x = gray.cols/2;
MidPoint.y = gray.rows/2;

bool err = false;

if(eye == 1) ///////////////////////////////L EYE ////////////////////////////////////////
{


    if(FastTrack == false)
    {
    /////////////////////////////////01/////////////////////////////////////
    Mat CircleMaskL01[8] = Mat::zeros(gray.rows,gray.cols,gray.type());
    Mat CircleMaskM = Mat::zeros(gray.rows,gray.cols,gray.type());
    Mat CircleMaskL = Mat::zeros(gray.rows,gray.cols,gray.type());
    cv::circle(CircleMaskM,MidPoint,gray.rows/2, CV_RGB(255,255,255),-1);
    Mat tester;
    double MaxValueBuffer=0;
    for(int i =2; i<8; i++)
    {
    cv::circle(CircleMaskL01[i],RDCorner,(gray.cols/8)*(i+1), CV_RGB(255,255,255),-1);
    bitwise_and(CircleMaskM,CircleMaskL01[i],CircleMaskL,noArray());
    bitwise_and(gray,CircleMaskL,tester,noArray());
    cv::minMaxIdx(tester,&minvalue,&maxvalue,0,0,noArray()); // find the min und max values
    if(maxvalue>MaxValueBuffer)
    {
    MaxValueBuffer = maxvalue;
    }
    else
    {
    gray=tester;
    Mat xxxx = tester;

    break;
    }
    }
    }
    //////////////////////////////////02/////////////////////////////////////
    else
    {






     Mat CircleMask = Mat::zeros(gray.rows,gray.cols,gray.type());  // create circle mask
     cv::circle(CircleMask,Point(gray.rows/2,gray.cols/2),gray.rows/2, CV_RGB(255,255,255),-1);
     bitwise_and(gray,CircleMask,gray,noArray());


    cv::minMaxIdx(gray,&minvalue,&maxvalue,0,0,noArray());

    }



    //////////////////////////////////DARKEST VALUE CHECK //////////////////////////

    if(CycleDetected<9)
    {
    if(!MaxValueMemoryL[0]){ std::fill_n(MaxValueMemoryL,8,maxvalue);}
    MaxValueMemoryL[7] = MaxValueMemoryL[6];
    MaxValueMemoryL[6] = MaxValueMemoryL[5];
    MaxValueMemoryL[5] = MaxValueMemoryL[4];
    MaxValueMemoryL[4] = MaxValueMemoryL[3];
    MaxValueMemoryL[3] = MaxValueMemoryL[2];
    MaxValueMemoryL[2] = MaxValueMemoryL[1];
    MaxValueMemoryL[1] = MaxValueMemoryL[0];
    MaxValueMemoryL[0] = maxvalue;
    }
    else
    {
    double MidValue = 0;
    for(int i=0;i<8;i++)
    {
    MidValue +=  MaxValueMemoryL[i]/8;
    }

    if(maxvalue < (MidValue+DarkPointRange) && maxvalue > (MidValue-DarkPointRange))
    {
    MaxValueMemoryL[7] = MaxValueMemoryL[6];
    MaxValueMemoryL[6] = MaxValueMemoryL[5];
    MaxValueMemoryL[5] = MaxValueMemoryL[4];
    MaxValueMemoryL[4] = MaxValueMemoryL[3];
    MaxValueMemoryL[3] = MaxValueMemoryL[2];
    MaxValueMemoryL[2] = MaxValueMemoryL[1];
    MaxValueMemoryL[1] = MaxValueMemoryL[0];
    MaxValueMemoryL[0] = maxvalue;
    }
    else
    {
    err =  true;
    }
    }


}
else ///////////////////////////////R EYE ////////////////////////////////////////
{


    if(FastTrack == false)
    {
    /////////////////////////////////01/////////////////////////////////////
    Mat CircleMaskR01[8] = Mat::zeros(gray.rows,gray.cols,gray.type());
    Mat CircleMaskM = Mat::zeros(gray.rows,gray.cols,gray.type());
    Mat CircleMaskR = Mat::zeros(gray.rows,gray.cols,gray.type());
    cv::circle(CircleMaskM,MidPoint,gray.rows/2, CV_RGB(255,255,255),-1);
    Mat tester;
    double MaxValueBuffer=0;
    for(int i =2; i<8; i++)
    {
    cv::circle(CircleMaskR01[i],LDCorner,(gray.cols/8)*(i+1), CV_RGB(255,255,255),-1);
    bitwise_and(CircleMaskM,CircleMaskR01[i],CircleMaskR,noArray());
    bitwise_and(gray,CircleMaskR,tester,noArray());
    cv::minMaxIdx(tester,&minvalue,&maxvalue,0,0,noArray()); // find the min und max values
    if(maxvalue>MaxValueBuffer)
    {
    MaxValueBuffer = maxvalue;
    }
    else
    {
    gray=tester;
    break;
    }
    }
    }
    //////////////////////////////////02/////////////////////////////////////
    else
    {


     Mat CircleMask = Mat::zeros(gray.rows,gray.cols,gray.type());  // create circle mask
     cv::circle(CircleMask,Point(gray.rows/2,gray.cols/2),gray.rows/2, CV_RGB(255,255,255),-1);
     bitwise_and(gray,CircleMask,gray,noArray());


    cv::minMaxIdx(gray,&minvalue,&maxvalue,0,0,noArray());

    }



    //////////////////////////////////DARKEST VALUE CHECK //////////////////////////

    if(CycleDetected<9)
    {
    if(!MaxValueMemoryR[0]){ std::fill_n(MaxValueMemoryR,8,maxvalue);}
    MaxValueMemoryR[7] = MaxValueMemoryR[6];
    MaxValueMemoryR[6] = MaxValueMemoryR[5];
    MaxValueMemoryR[5] = MaxValueMemoryR[4];
    MaxValueMemoryR[4] = MaxValueMemoryR[3];
    MaxValueMemoryR[3] = MaxValueMemoryR[2];
    MaxValueMemoryR[2] = MaxValueMemoryR[1];
    MaxValueMemoryR[1] = MaxValueMemoryR[0];
    MaxValueMemoryR[0] = maxvalue;
    }
    else
    {
    double MidValue = 0;
    for(int i=0;i<8;i++)
    {
    MidValue +=  MaxValueMemoryR[i]/8;
    }

    if(maxvalue < (MidValue+DarkPointRange) && maxvalue > (MidValue-DarkPointRange))
    {
    MaxValueMemoryR[7] = MaxValueMemoryR[6];
    MaxValueMemoryR[6] = MaxValueMemoryR[5];
    MaxValueMemoryR[5] = MaxValueMemoryR[4];
    MaxValueMemoryR[4] = MaxValueMemoryR[3];
    MaxValueMemoryR[3] = MaxValueMemoryR[2];
    MaxValueMemoryR[2] = MaxValueMemoryR[1];
    MaxValueMemoryR[1] = MaxValueMemoryR[0];
    MaxValueMemoryR[0] = maxvalue;
    }
    else
    {
    err =  true;
    }
    }




}



///////////////////////////////////////////////FIND THE DARKEST SPOT///////////////////////////////////////////////////////

if(err == false)
{


cv::threshold(gray,gray,maxvalue-MaxValueDepth, 255, cv::THRESH_BINARY);
std::vector<std::vector<cv::Point> > contours;
findContours(gray.clone(), contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_NONE);

uint CountOfDetections = (uint)contours.size();
drawContours(gray, contours, -1, CV_RGB(255,255,255), -1); // Fill holes in each contour
Point DetectedPoint;
Pupil PupilCandidates[CountOfDetections];


if(contours.size()>0)
{

    for (int i = 0; i < contours.size(); i++)
    {
        PupilCandidates[i].SetArea(cv::contourArea(contours[i]));  // Area
        PupilCandidates[i].SetPositionAndRatio(cv::boundingRect(contours[i])); // Bounding box around the shape
        if(eye == 1 ){PupilCandidates[i].SetDistance(PupilPositionBufferL[0]);} // Set the distances
        else{PupilCandidates[i].SetDistance(PupilPositionBufferR[0]); }
    }



if(CountOfDetections > 1) /// sort the candidates ///////////////////////////////CHART////////////////////////////////////
{


    for (int j = 0; j <(CountOfDetections-1); j++) // Y-pos descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( PupilCandidates[i+1].position.y >  PupilCandidates[i].position.y){swap(PupilCandidates[i],PupilCandidates[i+1]);}
    }
    }
    PupilCandidates[0].rate += 3;


    for (int j = 0; j <(CountOfDetections-1); j++) // area ascending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( PupilCandidates[i+1].area >  PupilCandidates[i].area){swap(PupilCandidates[i],PupilCandidates[i+1]);}
    }
    }
    PupilCandidates[0].rate += 3;

    for (int j = 0; j <(CountOfDetections-1); j++) // ratio ascending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( PupilCandidates[i+1].ratio >  PupilCandidates[i].ratio){swap(PupilCandidates[i],PupilCandidates[i+1]);}
    }
    }
    PupilCandidates[0].rate += 2;

    for (int j = 0; j <(CountOfDetections-1); j++) // ratio ascending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( PupilCandidates[i+1].distance <  PupilCandidates[i].distance){swap(PupilCandidates[i],PupilCandidates[i+1]);}
    }
    }
    PupilCandidates[0].rate += 2;

    for (int j = 0; j <(CountOfDetections-1); j++) // rate descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( PupilCandidates[i+1].rate >  PupilCandidates[i].rate){swap(PupilCandidates[i],PupilCandidates[i+1]);}
    }
    }
}

DetectedPoint = PupilCandidates[0].position;

double MidX,MidY;

if(eye == 1) // Calculate the absolute pupil position in frame
{

      PupilPositionBufferL[3] = PupilPositionBufferL[2];
      PupilPositionBufferL[2] = PupilPositionBufferL[1];
      PupilPositionBufferL[1] = PupilPositionBufferL[0];
      PupilPositionBufferL[0] = DetectedPoint;
      ActualPositionL = PupilPositionBufferL[0];


     if(CycleDetected>4)
    {


        MidY =  (PupilPositionBufferL[1].y+PupilPositionBufferL[2].y+PupilPositionBufferL[3].y +PupilPositionBufferL[0].y)/4;
        MidX =  (PupilPositionBufferL[1].x +PupilPositionBufferL[2].x +PupilPositionBufferL[3].x  +PupilPositionBufferL[0].x)/4;


      if(((abs(ActualPositionL.x - MidX)) < MaxMovementRange) && ( (abs(ActualPositionL.y - MidY)) < MaxMovementRange))
        {

          if(((abs(ActualPositionL.x - MidX)) > MinMovementRange) && ( (abs(ActualPositionL.y - MidY)) > MinMovementRange))
            {
            L_Pupil_Position = Point(((ActualPositionL.x + PupilPositionBufferL[1].x + PupilPositionBufferL[2].x)/3) + LCorner.x , ((ActualPositionL.y +PupilPositionBufferL[1].y +PupilPositionBufferL[2].y)/2) + LCorner.y);
            }
        else{
            L_Pupil_Position = Point(ActualPositionL.x + LCorner.x , ActualPositionL.y + LCorner.y);
            }
        }

    }
    else
    {
      L_Pupil_Position = Point( ((RoiPoints[2].x + RoiPoints[3].x)/2 ) , ((RoiPoints[2].y+RoiPoints[3].y )/2));
    }




}
else ///// FRAME 02 ///////////////////////////////////////////
{

    PupilPositionBufferR[3] = PupilPositionBufferR[2];
    PupilPositionBufferR[2] = PupilPositionBufferR[1];
    PupilPositionBufferR[1] = PupilPositionBufferR[0];
    PupilPositionBufferR[0] = DetectedPoint;
    ActualPositionR = PupilPositionBufferR[0];

   if(CycleDetected>4)
  {


      MidY =  (PupilPositionBufferR[1].y+PupilPositionBufferR[2].y+PupilPositionBufferR[3].y +PupilPositionBufferR[0].y)/4;
      MidX =  (PupilPositionBufferR[1].x +PupilPositionBufferR[2].x +PupilPositionBufferR[3].x  +PupilPositionBufferR[0].x)/4;


    if(((abs(ActualPositionR.x - MidX)) < MaxMovementRange) && ( (abs(ActualPositionR.y - MidY)) < MaxMovementRange))
      {

        if(((abs(ActualPositionR.x - MidX)) > MinMovementRange) && ( (abs(ActualPositionR.y - MidY)) > MinMovementRange))
          {
          R_Pupil_Position = Point(((ActualPositionR.x + PupilPositionBufferR[1].x + PupilPositionBufferR[2].x)/3) + RCorner.x , ((ActualPositionR.y +PupilPositionBufferR[1].y +PupilPositionBufferR[2].y)/2) + RCorner.y);
          }
      else{
          R_Pupil_Position = Point(ActualPositionR.x + RCorner.x , ActualPositionR.y + RCorner.y);
          }
      }

  }
  else
  {
    R_Pupil_Position = Point( ((RoiPoints[4].x + RoiPoints[5].x)/2 ) , ((RoiPoints[4].y+RoiPoints[5].y )/2));
  }




}
}



}
}





bool CheckLPupil = IsPointInsideRoi(L_Pupil_Position,RoiPoints[2],RoiPoints[3]);
bool CheckRPupil = IsPointInsideRoi(R_Pupil_Position,RoiPoints[4],RoiPoints[5]);

double Lchange = sqrt(pow((L_Pupil_Position.x - Trackers[7].x),2) + pow((L_Pupil_Position.y - Trackers[5].y),2)) +1;
double Rchange = sqrt(pow((R_Pupil_Position.x - Trackers[8].x),2) + pow((R_Pupil_Position.y - Trackers[6].y),2)) +1;

if( CheckLPupil == true){Trackers[7] = L_Pupil_Position;}
if( CheckRPupil == true){Trackers[8] = R_Pupil_Position;}



}
