#include "threadworker.h"

ThreadWorker::ThreadWorker(QObject *parent) : QObject(parent)
{
}








void ThreadWorker::Get_HSV_Data(uint *H_v, uint *S_v, uint *V_v, uint *R_v)
{
HSV_Colors[0][ColorCountHSV]=*H_v;
HSV_Colors[1][ColorCountHSV]=*S_v;
HSV_Colors[2][ColorCountHSV]=*V_v;
HSV_Colors[3][ColorCountHSV]=*R_v;
}

void ThreadWorker::Get_LIPS_Data(float *G_value, float *B_value)
{
LipsB = *B_value;
LipsG = *G_value;
}

void ThreadWorker::Get_EYES_Data(uint *Pup, uint *Dark, uint *Max, uint *Min, uint *Blur, uint *Depth, bool *FastTrack)
{

EyesAreaSize = *Pup;
EyesDarkPoint= *Dark;
EyesMaxMov= *Max;
EyesMinMov= *Min;
EyesBlur= *Blur;
EyesFastTracking= *FastTrack;
EyesDepth = *Depth;


}

void ThreadWorker::Get_EB_Data(uint *B1, uint *B2)
{
EbBlur1 = *B1;
EbBlur2 = *B2;
}







void ThreadWorker::Get_ComboBoxIndex(uint *In)
{
ComboBoxIndex = *In;

}

void ThreadWorker::Get_ColorIndex(uint *index)
{
    uint Ind = *index;
    if(ColorCountHSV > 0 && Ind == 0 ){ColorCountHSV--;}
    if(ColorCountHSV < 2 && Ind == 1 ){ColorCountHSV++;}



}

void ThreadWorker::Get_TrackingMethod(bool *TrackMethod)
{
ColorTrack = *TrackMethod;
}




void ThreadWorker::MouseLeft(Point *MPosition)
{
MousePosition = *MPosition;

}







void ThreadWorker::Initialize(Mat * DestinationImage, QString *DestinationData)
{

  DestinationImagePointer = DestinationImage;
  DestinationDataPointer = DestinationData;

  SampleImage = * DestinationImage;


  Start();

}




void ThreadWorker::Tracker(Mat * RawF)
{

 Frame = *RawF;  // get the full resolution frame
 Frame.copyTo(Frame_Trackers);
 Frame_FixedTrackers = Mat::zeros(Frame.rows,Frame.cols,Frame.type());



 /////////////// some trackers ////////////


   CreateColorMask(&Frame);  // create face mask for the whole frame

   RoiDetection();


   if(Face_Detected == true || FalseDetections <=60 ) // If some face ist detected, we can go ahead or if count of false detection isnt bigger than 60 frames = 2sec
   {

        EyeTrackerRun();
        if(ColorTrack == true)
         {
         MarkerSelector();
         }
        else
        {
         MouthTracker();
         EyeBrowTrackerRun();
        }
         GazeDetector();
         AlignTrackers();
         SmoothTrackers();
         Drawer();
         CycleDetected++;

        CycleDetected++;

   }
   else
   {
       CycleDetected = 0;
       qDebug()<<"No face!";
   }



   ////////////////SERVER PART////////////////////////
DataProcessing();
   //////////////////////////////////////////////////




   if(ComboBoxIndex == 0){ FinalFrame =Frame_Trackers;}
  if(ComboBoxIndex == 1){ FinalFrame =ColorMask;}
   if(ComboBoxIndex == 2){ FinalFrame =Frame_FixedTrackers;}







   FinalFrame.copyTo(*(DestinationImagePointer));
   *DestinationDataPointer = TrackingData;



}
